{% macro get_link(name, data) -%}
{% if name in data %}
{{ data[name].anchor_tag() }}
{% endif %}
{%- endmacro %}

{% macro pop_link(name, data) -%}
{% if name in data %}
{{ data[name].anchor_tag() }}
{% set _ = data.pop(name) %}
{% endif %}
{%- endmacro %}

{% macro pop_link_must_exist(name, data) -%}
{{ data[name].anchor_tag() }}
{% set _ = data.pop(name) %}
{%- endmacro %}

<h2 id="{{ section_name }}">{{ section_title }}</h2>
<p>
    It is highly recommended to read all of the Getting Started Guides in the order listed before reading
    the Developer or Additional Guides. If OpenCPI has already been installed, then you may skip the installation guide.
</p>
<div>{{ pop_link("release notes", links) }}</div>
<div>{{ pop_link("changelog", links) }}</div>
<div>{{ pop_link("man pages", links) }}</div>

<div class="flexbox-container">
    <div class="flexbox-item">
        <h3>Getting Started Guides</h3>
        {% if "opencpi installation" in links and "rpm installation" in links %}
        <div>{{ pop_link_must_exist("opencpi installation", links) }} or
            {{ pop_link_must_exist("rpm installation", links) }}
        </div>
        {% elif "opencpi installation" in links %}
        <div>{{ pop_link_must_exist("opencpi installation", links) }}</div>
        {% elif "rpm installation" in links %}
        <div>{{ pop_link_must_exist("rpm installation", links) }}</div>
        {% endif %}
        <div>{{ pop_link("opencpi user", links) }}</div>
        <div>{{ pop_link("getting started", links) }}</div>

        <h3>Developer Guides</h3>
        <div>{{ pop_link_must_exist("opencpi application development", links) }}</div>
        <div>{{ pop_link_must_exist("opencpi component development", links) }}</div>
        <div>{{ pop_link_must_exist("opencpi rcc development", links) }}</div>
        <div>{{ pop_link_must_exist("opencpi hdl development", links) }}</div>
        <div>{{ pop_link_must_exist("opencpi platform development", links) }}</div>
        {% if "opencpi component best practices" in links %}
        <p></p> <!-- for spacing -->
        <div>{{ pop_link("opencpi component best practices", links) }}</div>
        {% endif %}

        <h3>Additional Guides</h3>
        {% for name in links|sort %}
        <div>{{ links[name].anchor_tag() }}</div>
        {% endfor %}
    </div>

    <div class="flexbox-item">
        {% if briefings %}
        <h3>{{ briefings.title }}</h3>
        {% for name in briefings.files|sort %}
        <div>{{ briefings.files[name].anchor_tag() }}</div>
        {% endfor %}
        {% endif %}
    </div>

    <div class="flexbox-item">
        {% if tutorials %}
        <h3>{{ tutorials.title }}</h3>
        {% for name in tutorials.files|sort %}
        <div>{{ tutorials.files[name].anchor_tag() }}</div>
        {% endfor %}
        
        <h3>Video Tutorials</h3>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=Wi3vgOEIfTk" target="_top">OpenCPI - v2.1.0 Zedboard SD Card Artifacts</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=yYprMUij4lo" target="_top">Framework Installation - Zedboard</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=vPz7P2yz01I" target="_top">Dynamically Change Frequency using DRC</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=YBkl-hAQQV8" target="_top">DRC Transmit Release</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=j4usLoRUqPc" target="_top">Throughput Measurement Tests</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=0IEVWqQOvxY" target="_top">Bug Fix DRC set gain to manual</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=W5zoGY9xl0E" target="_top">Timegate Worker Test Application</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=dnoT0jaWWwI" target="_top">Zedboard FMCOMMS2/3 Bug Fix</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=Fk9dXgeG6dY" target="_top">Upgrade Ettus E310 Software Platform</a></div>
        <div><a class="ulink" href="https://www.youtube.com/watch?v=kW_wQyhcSB4" target="_top">OSP Development Workshop</a></div>
        {% endif %}
    </div>
</div>
